---
schema_version: "1"
id: 66c3ffd535458f789c39453c4c505be433a46d1f558355ebdf89ac296535e06d
title: What's New-Tableau Server REST API
collection: tableau
version: next
locale: en-us
portal_url: https://docs.salesforce.com/tableau/next/en-us/api/rest_api/REST/rest_api_whats_new.md
canonical_url: https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_whats_new.htm
source_site: help.tableau.com
content_type: documentation
content_hash: 1c21f59a2f9e6598d51fa7b37ab0c14617f7b34146fd8841f2f72294e1578ea8
description: This topic summarizes changes made to the REST API for Tableau Server and Tableau Cloud
---
[Skip to main content](#main-content)

# What's New in the REST API

This topic summarizes changes made to the REST API for Tableau Server and Tableau Cloud. All versions include updated documentation.

## REST API 3.30 (Tableau Cloud October 2026 / Tableau Server 2026.3)

- Tableau now supports managing Bridge routing rules via the REST API. A routing rule routes a domain's Bridge queries to a specific pool (optionally scoped to projects) or blocks a domain from being routed. New endpoints let you create, get, update, and delete routing rules, and add or remove project scoping on an allow rule. For information, see [Bridge Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_bridge.htm).
- Tableau now supports editing published data sources via the REST API. Create a work copy of a published data source, read, add, update, or delete its columns, field descriptions, and table descriptions, and then publish the work copy as a data source. You can also read these elements directly from a published data source. These methods complement [VizQL Data Service](https://help.tableau.com/current/api/vizql-data-service/en-us/index.html): VizQL Data Service queries data sources, and these methods author them. Requires Data Management or Tableau+. For information, see [Data Sources Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#create_work_copy).

## REST API - New Feature (Tableau Cloud September 2026)

- Knowledge Graph methods: New methods let you explore the Tableau Knowledge Graph programmatically. Search nodes, trace lineage and downstream impact, and attach semantic context to your content. For information, see [Tableau Knowledge Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_tableau_knowledge_graph.htm).

## REST API 3.29 (Tableau Cloud June 2026 / Tableau Server 2026.2)

- Tableau MCP now supports per-site configuration via the REST API, allowing administrators to customize settings at the site level. When a Tableau MCP user authenticates to a site, that site's specific MCP configuration is applied for tailored access control and functionality. For information, see [Tableau MCP Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_tableau_mcp.htm).
- Tableau now supports interacting with the Recycle Bin via the REST API. New endpoints allow users to get or list content, restore content, and permanently delete some or all content. For information, see [Recycle Bin Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_recycle_bin.htm).
- Tableau now supports interacting with Bridge via the REST API. Using the Bridge methods of the Tableau REST API you can:
    
    - Bridge clients: List Bridge clients for a site or get details for a specific Bridge client; delete a Bridge client; move a Bridge client between pools or to unassigned status.
    - Bridge pools: List, create, update, and delete Bridge pools. [Bridge pools](https://help.tableau.com/current/online/en-us/to_enable_bridge_live_connections.htm) are logical groupings of Bridge clients for load distribution and management.
    - Bridge domains: Add domains to pools, block domains, update domain names or pool assignment, get domain mapping, and delete domain mappings.
    
    For information, see [Bridge Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_bridge.htm).
- On-demand access update: Beginning in July 2026, on-demand access is supported for Tableau Cloud sites licensed with the [capacity-based model](https://help.tableau.com/current/online/en-us/license_product_keys.htm#capacity) (Cloud+ or Tableau+ edition) in addition to the usage-based model. Enable on-demand access with the `externalUserEnabled` attribute using the [Create Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#create_group) and [Update Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_group) methods.
- [Data Acceleration (Retired)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_acceleration.htm)\-related methods and attributes were retired.

## REST API 3.28 (Tableau Cloud February 2026)

- Starting in March 2026, you can set the default language and locale for users using the [Add User to Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#add_user_to_site) and [Update User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_user) methods.
- Collections Methods: New REST API endpoints let you programmatically create, retrieve, update, and delete Tableau collections. You can list collections accessible to the signed-in user, manage collection items across projects, update properties in batch, and transfer ownership between users. The endpoints support filtering by resource type, owner, visibility (public/private), timestamps, and favorites, as well as sorting by various fields including custom item position. Users accessing shared collections will only see items they have permissions to view. See [Collections Methods](https://help.tableau.com/current/api/rest_api/en-us/REST/TAG/index.html#tag/Collections-Methods).
- Permissions methods for collections: To complement the new collections methods, now you can also add, list, and delete permissions on collections. See [Collections Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_collections.htm).
- New security options for trusted extensions: The [List Tableau Extension Site Settings](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_tableau_extensions_settings.htm#list_tableau_extensions_site_settings) and [Update Tableau Extension Site Settings](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_tableau_extensions_settings.htm#update_tableau_extensions_site_settings) methods now include the `allowTrusted` attribute and three new sub-options: `includeSandboxed`, `includeTableauBuilt`, and `includePartnerBuilt`. These settings allow you to automatically permit specific categories of trusted extensions to run without requiring individual entries on the safe list.
- Delegate extract refreshes: The [Add Data Source Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_permissions.htm#add_data_source_permissions) and [Add Workbook Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_permissions.htm#add_workbook_permissions) methods now support the `ExtractRefresh` capability. This allows admins and owners to grant other users the ability to [manually trigger refreshes](https://help.tableau.com/current/online/en-us/permissions.htm#allow-other-users-to-refresh-extracts), ensuring teams can maintain data freshness even when the asset owner is unavailable.
- Incremental refresh support for on-demand updates: You can now specify an incremental refresh when using the [Update Data Source Now](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_source_now) and [Update Workbook Now](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook_now) methods by adding `incremental="true"` to the `extractRefresh` element in the request body.
- Access scopes are now supported across additional Tableau REST OpenAPI methods, including [Analytics Extensions Settings](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_analytics_extensions_settings.htm) and [Custom Domains](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_custom_domain.htm).
- SCIM configurations now support OIDC and Google authentication in Tableau Cloud. To configure SCIM, see [Create SCIM Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#create_scim_configuration).
- Increased file upload reliability: The updated [Append to File Upload](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_publishing.htm#append_to_file_upload) method now supports a sequenceID parameter in the URI querystring. Using the sequenceID parameter ensures files are assembled in order, and therefore helps prevent corruption of the uploaded file.
- Starting April 2026, flow updates:
    
    - Use the new [Update Flow Connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#update_flow_connections) to update the server address, port, username, or password and more for one or more flow connections.
    - Specify `authenticationType` in [Update Flow Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#update_flow_connection) and [Update Flow Connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#update_flow_connections) to update the authentication type for flow connections.

## REST API 3.27 (Tableau Cloud December 2025 / Tableau Server 2025.3)

- Starting in December 2025:
    
    - For Tableau Cloud, you can authorize access to the Tableau REST API using unified access token (UAT) JWTs. For more information, see [Sign in with unified access tokens JWT](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_auth.htm#uat).
    - For Tableau Cloud, as part of the UAT JWT support, new and existing scopes can be used in UAT JWTs to define access to Tableau REST API methods.
    - For Tableau Cloud, additional scopes were added to support Tableau connected apps JWTs. For more information, see [Sign in with connected apps JWT](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_auth.htm#connected_apps).
    - For Tableau Server, a subset of additional scopes were added to support Tableau connected apps.
- Also starting in December 2025 in Tableau Cloud, when using connected apps with direct trust for embedding workflows, you can use the [Signing In and Signing Out (Authentication)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_auth.htm#sign_out) method to end a user's Tableau session when they sign out of your application. This ensures embedded visualizations are no longer accessible after the user signs out.
- Bulk activate or suspend schedules: The new [Batch Update Schedule State](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_jobs_tasks_and_schedules.htm#batch_update_schedule_state) method for Tableau Server activates or suspends a set of schedules, even all of them at once, making preparations for processes like system maintenance easier.
- Delete views from workbooks: The new [Delete View](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#delete_view) method deletes a view from a workbook. This method is useful for simply removing views, but it can also be used alongside other methods to delete hidden views when republishing or migrating to a different environment.
- Change the owner of a flow: The new **Set Flow Owner** method changes the owner of a flow.
- Refresh all thumbnail images for a workbook: The new [Refresh Workbook Thumbnail Images](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook) method generates thumbnails for each view in a workbook. Use this new method during migration to Tableau Cloud, or other times you need to refresh the thumbnail images.
- Update authentication type on connections. The [Update Data Source Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_source_connection) and [Update Workbook Connection](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook_connection) methods now allow you to change authentication type.
- Update specific connections in data sources and workbooks containing multiple connections. The [Update Data Source Connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_source_connections) and [Update Workbook Connections](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook_connections) methods allow you to update individual connections.
- Use the `attributeCaptureEnabled` attribute in the [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#update_site) method to enable user attribute functions in Tableau Cloud OIDC and SAML SSO workflows.

## REST API 3.26 (Tableau Cloud June 2025)

- New for Pulse: Starting in September 2025:
    
    - [Generate insight brief](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#EmbeddingsService_GenerateInsightBrief) enables you to provide a synopsis in answer to a user's question by gathering relevant insights for the specified metrics.
    - [Generate breakdown insight bundle](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseInsightsService_GenerateInsightBundleBreakdown) lets you generate a breakdown insight bundle, showing the breakdown of the metric by the specified dimensions.
    - [Generate exploration insight bundle](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseInsightsService_GenerateInsightBundleExploration) enables you to generate an insight bundle with suggested follow up questions.
- The [Download Workbook PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#download_workbook_pdf) method now enables you to set the width and height of the download.
- Starting in July 2025, Tableau Cloud supports specifying an email address for a user that is different from their username. The email address can be used for receiving notifications only. If the `email` attribute is not specified, Tableau Cloud will continue to use the `username` value to send notifications to. For more information, see the [Add User to Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#add_user_to_site) and [Update User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_user) methods.
- Beginning in August 2025, you can configure multiple SCIM configurations for a site. For more information, see [Create SCIM Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#create_scim_configuration), [Create SCIM Token](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#create_scim_token), [Get SCIM Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#get_scim_configuration), [Update SCIM Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_scim_configuration), [List SCIM Configurations](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#list_scim_configurations), [Delete SCIM Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#delete_scim_configuration), and [Delete SCIM Token](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#delete_scim_token) methods.

## REST API 3.25 (Tableau Cloud February 2025 / Tableau Server 2025.1)

- New for Pulse: Starting in March 2025:
    
    - New Pulse Methods
        - [Create metric tag](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_CreateTag) and [Delete metric tag](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_DeleteTag) methods enable users to add or remove custom user-defined tags to a metric, or a system-defined `mute-from-summary` tag that prevents the metric from appearing in insight summaries. Both user-defined and system-defined tags are listed in responses that show metric details.
        - [List metric definition measurement periods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseInsightsService_GetMeasurementPeriods) lets you see the measurement periods configured for a metric definition.
        - [List site alerts](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#AlertService_ListAlerts) lets you see the alerts that are configured for a site. Currently only the unfavorable trend alert type is supported.
    - New Pulse Elements
        - Metric definition methods now support related links. You can specify up to 5 links in the [Create metric definition](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_CreateDefinition) and [Update metric definition](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_UpdateDefinition) methods, and view link details wherever metric definitions are present in a response.
        - User permissions to create Pulse metrics from a data source can now be viewed and managed with the `PulseMetricDefine` capability in the [Add data source permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_permissions.htm#add_data_source_permissions) and [List data source permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_permissions.htm#query_data_source_permissions) methods.
        - Metric definition extension options now include `custom_calendar` that lets you configure the calendar of metrics in the definition using data in your data source.
- Use the `attributeCaptureEnabled` attribute in the [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#update_site) method to enable user attributes for Tableau Server embedding workflows.
- The [Query Job](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_jobs_tasks_and_schedules.htm#query_job) and [Query Jobs](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_jobs_tasks_and_schedules.htm#query_jobs) methods now support the `tableau:jobs:read` scope if users authenticate with a JWT.
- Added methods for downloading and uploading encrypted flows. For more information, see [Download Flow Encrypted Keychain](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#download_flow_encrypted_keychain) and [Upload Flow Encrypted Keychain](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#upload_flow_encrypted_keychain) methods.

## REST API 3.24 (Tableau Cloud October 2024)

- New for Pulse: Starting in December 2024:
    
    - New Pulse insight type
        - `INSIGHT_TYPE_RECORD_LEVEL_OUTLIERS` shows values that fell outside of the range of most of the rest of the values for a metric.
    - New Pulse Methods
        - [Generate basic insight bundle](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseInsightsService_GenerateInsightBundleBasic) enables you to create a Basic insight bundle. Basic insights are similar to a springboard insight, but data is focused on the dimensions of a metric that are low bandwidth because they have small value sets.
        - [List Pulse user preferences](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseSubscriptionService_GetUserPreferences) lets you view the signed in user's preferences, optionally sorted and grouped.
        - [Update Pulse user preferences](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseSubscriptionService_UpdateUserPreferences) lets you modify the signed in user's preferences.
        - [Batch list metric definitions (many)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_BatchGetDefinitionsByPost) lets you specify large batches of definitions to view.
    - New Pulse Enumerations
        - [List followed metrics groups](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#PulseSubscriptionService_ListFollowedMetricsGroups) With the new group by value `GROUP_BY_TIME_RANGE`, you can group returns by time period.
        - With the new metric specification comparison type `TIME_COMPARISON_FISCAL_YEAR_AGO_PERIOD`, you can configure comparisons based on fiscal year.
        - With the new definition insight option type `INSIGHT_TYPE_UNUSUAL_CHANGE` you can now configure your insight to highlight unusual changes in your data.
        - A new definition basic specification measure value `AGGREGATION_USER` lets you aggregate insight data by user.
        - Two new measurement period granularity values `GRANULARITY_BY_FISCAL_YEAR` and `GRANULARITY_BY_FISCAL_QUARTER` now let you define the measurement period of of a metric specification by fiscal year or fiscal quarter.
        - Two new measurement period granularity values `GRANULARITY_BY_FISCAL_YEAR` and `GRANULARITY_BY_FISCAL_QUARTER` now let you define the measurement period of of a metric specification by fiscal year or fiscal quarter.
    - New Pulse Parameters
        - [List metrics in definition](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_ListMetrics) With newly added parameters you can: specify the type of metric to return; sort results by metric name ascending or descending; and choose to exclude metrics without followers.
        - For requests and responses about definitions:
            - `datasource_goals` define a metric with a target that is calculated from values in the definition's data source. This is as opposed to a metric goal whose value is defined directly in the request.
        - Returned for requests about insights:
            - `InsightFeedbackMetadata`, giving you programmatic access to user thumbs up/down feedback on insights.
            - `generation_id`, the LUID of the insight.
            - `table` the columns and rows of the data table produced by filtering your datasource as defined in your metric specification.
        - Returned for insight bundles options:
            - `language` and `locale`, let you define the language characteristics of your insights.
            - `score_weights` let you refine the weighting of data in your insights.
    - Deprecated in Pulse methods
        - In API 3.24 (Tableau Cloud December 2025) and later, [Batch list metric definitions (few)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_BatchGetDefinitions) method is deprecated and may be retired in future releases. Instead use the [Batch list metric definitions(many)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_BatchGetDefinitionsByPost) method. That method has the same behavior but supports listing larger batches of definitions.
- New REST API method for downloading a PDF image of a custom view using the [Get Custom Views PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#get_custom_view_pdf) method.
- New REST API method for downloading the data of a custom view in CSV format using the [Get Custom Views Data](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#get_custom_view_data) method.
- Added in this REST API version: When using the [Download Workbook PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#download_workbook_pdf) method, you can now filter the downloaded view. For more information, see [View filter queries](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_filtering_and_sorting.htm#Filter-query-views).
- Added in this REST API version: When using the [Query View Image](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#query_view_image) method, you can now set the height and width of the downloaded viz.
- New REST API methods for downloading and uploading workbook encrypted keychains. For more information, see [Workbooks and Views Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm).
- New REST API methods for downloading and uploading user credentials. For more information, see [Users and Groups Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm).

- Starting in January 2025, Tableau Cloud supports the configuration of multiple authentication types for a site. This capability introduces the following changes:
    
    - Use the [List Authentication Configurations for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#list_authentication_configurations_site) method to query the authentication configurations on the site and get the `idpConfigurationId` value for each authentication configuration.
    - You will now use the `idpConfigurationId` attribute to assign authentication to a user. You can continue to use the `authSetting` attribute when assigning authentication to configurations that Tableau has added the "Initial" prefix to. For more information, see [Add User to Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#add_user_to_site) or [Update User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_user) methods.
    - For the [Create OpenID Connect Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_openid_connect.htm#create_openid_connect_configuration) method, include `idpConfigurationName`; for the [Update OpenID Connect Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_openid_connect.htm#update_openid_connect_configuration) method, include the `idpConfigurationId`; for [Remove OpenID Connect Configuration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_openid_connect.htm#remove_openid_connect_configuration) method, include the `idpConfigurationId` in the URI.

## REST API 3.23 (Tableau Cloud June 2024 / Tableau Server 2024.2)

- Pulse method additions to API 3.23 in Tableau Cloud July 2024
    
    - New Method: [Get site entitlements](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_GetEntitlements) lets any user to see the advanced features enabled for sites they have access to.
    - [Batch list metric definitions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_pulse.htm#MetricQueryService_BatchGetMetrics) now has support for grouping and sorting returned metrics.
- Enabling and disabling query tagging for individual connections using the `queryTaggingEnabled` attribute of the [Update Workbook Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_workbook_connection) and [Update Data Source Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_source_connection) will no longer be supported and may be retired in future releases. For more information, see [Query Tagging](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_how_to_query_tagging.htm).
- Tableau Server supports registering one or more EASs at the site level for Tableau connected apps using OAuth 2.0 trust. For more information, see [Connected App Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm).
- Tableau Server supports specifying multiple projects to enable embedding of content for Tableau connected apps using direct trust. For more information, see [Create Connected App](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#create_connectedapp) and [Update Connected App](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#update_connectedapp) methods.
- New REST API methods to help with migrating Virtual connections from Tableau site to Tableau site, including Tableau Server to Tableau Cloud. Includes methods to download, publish, delete, tag, and change permissions. For more information, see [Virtual Connections Methods.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_virtual_connections.htm)
- New REST API methods for replacing permissions and default permissions. For more information, see [Permissions Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_permissions.htm).
- The labels methods support scopes if users authenticate with a JWT. This gives the administrator more authorization granularity for these methods. For more information, see the labels methods at [Metadata Methods.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm)
- Starting in July, Tableau Cloud supports a new REST API method for generating workbook, data source, and table descriptions. For more information, see the [Get Metadata Suggestion](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#get_metadata_suggestion) method.

## REST API 3.22 (Tableau Cloud February 2024)

- Add Flow Task to Schedule renamed to Add Flow Task to Server Schedule and retired for Tableau Cloud in API 3.22 in March 2024:
    
    > > [!WARNING]
    > > 
    > > The Add Flow Task to Schedule method is renamed and retired for Tableau Cloud in API 3.22 March 2024. It will remain available for Tableau Server only. This method will be replaced with Create Flow Task with Custom Schedule method.
- As a Tableau Cloud site admin, you can configure OpenID Connect (OIDC) to authenticate your users. For more information, see [OpenID Connect Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_openid_connect.htm).
- As a Tableau Cloud site admin, you can configure your Tableau connected app (direct trust) to enable content in multiple projects to be embedded. For more information, see [Create Connected App](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#create_connectedapp) and [Update Connected App](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#update_connectedapp) methods.
- As a Tableau Cloud site admin, you can configure your Tableau connected apps (OAuth 2.0 trust) to use different external authorization servers (EASs). For more information, see [Register EAS](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#create_connectedapp_eas) and [Update EAS](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#update_connectedapp_eas) methods.
- Added support to filter groups by `luid`and `id` for better performance. For more information, see [Query Groups](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_groups).
- View acceleration and data freshness policy for view acceleration and query caching can now be enabled and managed for a workbook through the [Update Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook) method. You can now get the status of these configurations for each workbook and its views through the [Get Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#get_workbook) method.
- There is no longer a limit on the number of data labels per category on an asset, and a label message is no longer required for any category of label. Furthermore, the length limit for label value names and category names is increased from 24 to 128 characters. For more information, see [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- Query tagging changes: In Tableau Server 2023.3 and later, the TSM `configuration set [native_api.UserInfoInGeneratedSQLEnabled](https://help.tableau.com/current/server/en-us/cli_configuration-set_tsm.htm#nativeapiUserInfoInGeneratedSQLEnabled)` key is available to enable or disable query tagging for all content on the server.
- Starting in July 2024 in Tableau Cloud, include the name of the authentication configuration when assigning authentication to a user.

## REST API 3.21 (Tableau Cloud October 2023/ Tableau Server 2023.3)

- [Pulse methods for managing metric definitions, metrics, insights and subscriptions](https://help.tableau.com/current/api/rest_api/en-us/REST/TAG/index.html#tag/Pulse-Methods) are available for Tableau Cloud sites.
- Ask Data Lens and Metrics Methods: retired in API 3.22 (Tableau Cloud February 2024 / Server 2024.2)
    
    **Retired in API 3.22 (Cloud February 2024 / Server 2024.2)**
    
    Tableau's legacy metrics feature was retired in Tableau Cloud in February 2024 and in Tableau Server version 2024.2. In October 2023, Tableau retired the ability to embed legacy metrics in Tableau Cloud and in Tableau Server version 2023.3. With Tableau Pulse, we've developed an improved experience to track metrics and ask questions of your data. For more information, see [Create Metrics with Tableau Pulse](https://help.tableau.com/current/online/en-us/pulse_create_metrics.htm) to learn about the new experience and [Create and Troubleshoot Metrics (Retired)](https://help.tableau.com/current/online/en-us/metrics_create.htm) for the retired feature.
- [Tableau Extensions Settings Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_tableau_extensions_settings.htm) have been added to for allowing and disallowing extensions on Tableau Cloud and Server. They replace the now retired Dashboard Extensions Settings Methods.
- Dashboard Extensions Settings Methods: retired in API 3.21 (Tableau Cloud October 2024 / Server 2023.3)
    
    > > [!WARNING]
    > > 
    > > In October 2023 Tableau Cloud and Tableau Server version 2023.3 releases, Tableau's REST API methods for dashboard extensions settings are retired. We recommend you replace dashboard extensions methods for enabling, listing, getting details of, and updating dashboard extensions with [Tableau extensions settings methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_tableau_extensions_settings.htm) that have similar functionality.
- New [List Users with Custom View as Default](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#list_users_with_custom_view_as_default) and [Set Custom View as Default for Users](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#set_custom_view_as_default_for_users) methods enable you to use the REST API to manage default custom view settings for users.
- As part of the personal access tokens (PATs) enhancements, [list personal access tokens](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm#list_personal_tokens) and [revoke personal access token](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm) methods are available for Tableau Cloud site admins and users.
- The [Update Embedding Settings for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#embedding_settings_for_site) method enables Tableau Server users (previously Tableau Cloud users only) to control where Tableau content can be embedded when an external application uses a Tableau connected app with OAuth 2.0 trust for authentication.
- Enable on-demand access using the [Create Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#create_group) and [Update Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#update_group) methods to allow users who are not provisioned on a Tableau Cloud site licensed with Embedded Analytics usage-based model to interact with embedded Tableau content.
- [Create Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_projects.htm#create_project) and [Update Project methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_projects.htm#update_project) now enable you to specify a project's owner.
- The labelCategories methods allow an administrator to create, update, or delete data label categories, giving their users more control over the classification of assets. For more information, see [Data Labels in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_labels.htm) and the labelCategories methods in [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- You can bulk add and bulk remove users from a group. For more information, see [Add User to Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#add_user_to_group) and [Remove User from Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#remove_user_to_group).
- For Tableau Server (previously Tableau Cloud only), both the [Sign In](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm#sign_in) and [Sign Out](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm#sign_out) methods are supported by JWT authorization but do not require scopes to use.

## REST API 3.20 (Tableau Cloud June 2023)

- The new [Create Data Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_notifications.htm#create_data_driven_alert) method enables you to create and configure a data driven alert programmatically for Tableau Cloud sites.
- New methods for Tableau Cloud extract refresh and subscriptions tasks offer more customizable frequency configuration. See:
    - [Create Cloud Extract Refresh Task](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_extract_and_encryption.htm#create_cloud_extract_refresh_task)
    - [Update Cloud extract refresh task](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_extract_and_encryption.htm#update_cloud_extract_refresh_task)
    - [Get Extract Refresh Task (Tableau Cloud Request)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_extract_and_encryption.htm#tableau-cloud-request)
    - [List Extract Refresh Task (Tableau Cloud Request)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_extract_and_encryption.htm#tableau-cloud-request1)
    - [Create Subscription (Tableau Cloud Request)](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#tableau-cloud-request)
    - [Get Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#tableau-cloud-request1) (Tableau Cloud Request)
    - [Update Subscriptions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#tableau-cloud-request3) (Tableau Cloud Request)
- The [Update Embedding Settings for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#embedding_settings_for_site) method now enables users to control where Tableau content can be embedded when an external application uses a Tableau connected app with OAuth 2.0 trust for authentication.
- The labelValues methods allow an administrator to customize existing label values or create entirely new ones, giving their users more control over the classification of assets. For more information, see [Data Labels in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_labels.htm) and the labelValues methods in [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- Both the [Sign In](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm#sign_in) and [Sign Out](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm#sign_out) methods are supported by JWT authorization but do not require scopes to use.
- The [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#publish_workbook) and [Update Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_workbook) methods support adding a description to the workbook.

## REST API 3.19 (Tableau Cloud March 2023/ Tableau Server 2023.1)

- As a Tableau Server administrator, you can use the [Identity Pools Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_identity_pools.htm) to provision and authenticate Tableau Server users.
- As a Tableau Cloud site administrator, you can enable the user attributes site setting for embedding workflows using the [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#update_site) method.
- Methods for working with virtual connections—previously available only for Tableau Cloud—are now available for Tableau Server. Use the [List Virtual Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#ref_list_virtual_connections) to get a list of virtual connections and details for each, the [List Virtual Connection Database Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#ref_list_virtual_connection_database_connections) to retrieve database connection information, and the [Update Virtual Connection Database Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_virtual_connection_database_connections) to update database connection information.
- Using the new content exploration method [Get content suggestions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_content_exploration.htm#-content-exploration-service_get-suggestions) you can now get suggestions for relevant content returned to display completion options as a user types.
- [Ask data lens](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_ask_data_lens.htm) methods now support [JWT access scopes](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm) so that permissions to use them can be granted to connected apps.

## REST API 3.18 (Tableau Cloud December 2022)

- New methods are available for working with virtual connections. Use the [List Virtual Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#ref_list_virtual_connections) to get a list of virtual connections and details for each, the [List Virtual Connection Database Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#ref_list_virtual_connection_database_connections) to retrieve database connection information, and the [Update Virtual Connection Database Connections method](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_virtual_connection_database_connections) to update database connection information.
- You can use the new [Get usage statistics](https://help.tableau.com/current/api/rest_api/en-us/REST/TAG/index.html#operation/UsageStatsService_GetUsageStats) and [Get batch usage stats](https://help.tableau.com/current/api/rest_api/en-us/REST/TAG/index.html#operation/UsageStatsService_GetUsageStatsBatch) content exploration methods to discover how users are accessing your content.
- [Mobile Settings Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_mobile_settings.htm) enable you to view and control the Tableau mobile client security settings of mobile apps that access your site.
- Custom view methods now allow you to [get a list of custom views on a site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#list_custom_views), [get the details of a custom view](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#get_custom_view), [download an image of it](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#get_custom_view_image), [delete it](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#delete_custom_view), or [update its name or owner](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#update_custom_views).
- Tableau Server administrators can [delete a site asynchronously](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#async) to track deletion progress.

## REST API 3.17 (Tableau Cloud October 2022 / Tableau Server 2022.3)

- As a Tableau Cloud site admin, you can register an external authorization server (EAS) to a site to establish a trust relationship between the EAS and your site using the OAuth 2.0 standard protocol. This trust relationship enables you to provide your users with a single sign-on (SSO) experience to Tableau content embedded in your custom applications or for REST API authorization. For more information, see [Connected app methods using OAuth 2.0 trust](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm#eas).
- As a Tableau Server admin, you can programatically authorize access to the Tableau REST API on users' behalf using JSON web tokens (JWTs) and Tableau connected apps. For more information, see [Access Scopes for Connected Apps](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm) in the Tableau Server Help.
- Methods to manage data labels—originally released for Tableau Cloud only—are now available for Tableau Server. Label methods offer a new, unified interface for manipulating certification and data quality warnings through the REST API. For more information, see the [Data Labels in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_labels.htm) topic and the label methods in [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- The ability to move databases and tables—originally released for Tableau Cloud only—is now available for Tableau Server. You can move databases and tables to projects, enabling you to control permissions through them. For more information, see the [Move Database](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#move_database) and [Move Table](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#move_table) methods in the Tableau REST API Reference.
- Now you can set data quality warnings on columns. Relevant methods for data quality warnings and data labels were updated to include support for columns.
- You can now get the details of a workbook using the [Get Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbook) method with the content URL of the workbook (the part that appears after `…/authoring/…` or `…/views/…` in the URL path of the workbook in your browser address bar).

## REST API 3.16 (Tableau Cloud June 2022)

- As a Tableau Cloud site admin, you can programatically authorize access to the Tableau REST API on users' behalf using JSON web tokens (JWTs) and Tableau connected apps. For more information, see [Access Scopes for Connected Apps](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm) in the Tableau Cloud Help.
- Label methods offer a new, unified interface for manipulating certification and data quality warnings through the REST API. For more information, see the [Data Labels in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_labels.htm) topic and the label methods in [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- You can move databases and tables to projects, enabling you to control permissions through them. For more information, see the [Move Database](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#move_database) and [Move Table](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#move_table) methods in the Tableau REST API Reference.
- As a Tableau Cloud site admin, you can restrict embedding of Tableau views to only certain domains of your choice. For more information see the embedding setting methods in [Site Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm)

## REST API 3.15 for Tableau Server 2022.1 and Tableau Cloud

- As a Tableau Server admin or Tableau Cloud site admin, you can list and change user notification preferences for your site. For more information, see [Notifications Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_notifications.htm).
- The Data-Driven Alerts methods and the Webhooks methods were moved to the [Notifications Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_notifications.htm) page.
- REST API methods are now available that enable multiple users to be imported to or deleted from a site from a .csv list of users. The .csv data can also include site role and authorization settings that will be assigned for each user upon import. For more information, see [Import Users to Site from CSV](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#import_users_to_site_from_csv) and [Delete Users from Site with CSV](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_users_and_groups.htm#delete_users_from_site_with_csv).
- New methods related are now available to run and get information on linked tasks. Linked tasks are used to schedule flows to run one after the other. For more information, see [Flow Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm).
- New attributes to support flow parameters have been added to various flow methods including methods that are used to run flows. You can use REST API to override flow parameter values at run time. For more information, see [Flow Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm).
- Methods related to certification and data quality warnings have been expanded to include support for virtual connections and virtual connection tables. For more information, see [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).

## REST API 3.14 for Tableau Server 2021.4 and Tableau Cloud

- As a Tableau Server admin or Tableau Cloud site admin, you can create, query, update, and delete Tableau connected apps configured for your site. For more information, see [Connected App Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_connected_app.htm).
- The [publish data source](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#publish_data_source) method now supports multi table data created using the Hyper API, as long as there is a single fact table containing the foreign key for each of the other tables in the extract.

## REST API 3.13 for Tableau Server 2021.3 and Tableau Cloud

- Add, update, query, and delete data quality certifications for databases, tables, and data sources using the following methods: [Add (or Update) Data Quality Certifications](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_dqw_certification), [Query Data Quality Certification by ID](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_dqw_certification), [Query Data Quality Certifications by Content](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_dqw_certifications), [Delete Data Quality Certification by ID](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_dqw_certification), and [Delete Data Quality Certifications by Content](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_dqw_certifications).
- Query databases and tables from the connection information in the data source or workbook file's XML using [Get Databases and Tables from the Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_xml_databasestables).
- Enable data quality warnings (DQWs) in subscription emails for your site using the [Create Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_site) or [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_site) method.
- If needed, you can disable Explain Data per site using the [Create Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_site) or [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_site) method.
- Manage default permissions for lenses and data roles with the [Add Default Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_default_permissions), [Query Default Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_default_permissions), [Delete Default Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_default_permission) methods.
- Understand Workbook Impact on Your Database Using [Query Tagging](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_how_to_query_tagging.htm).

## REST API 3.12 for Tableau Server 2021.2 and Tableau Cloud

- You can modify (insert, update, upsert, replace, and delete) data in a published data source that is a live-to-Hyper connection. Use [Update Data in Hyper Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_in_hyper_data_source) or [Update Data in Hyper Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_in_hyper_connection). For more information, see [Update data in published live-to-Hyper data sources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_how_to_update_data_to_hyper.htm).
- With the appropriate permissions, you can batch add (or update), and delete multiple data quality warning (DQW) items to and from different content and external assets using the following methods: [Batch Add Data Quality Warnings](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#batch_add_dqws) and [Batch Delete Data Quality Warnings](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#batch_delete_dqws).
- Server and Site administrators can now directly find the Tableau resource responsible for a problematic data source query when they enable [query tagging](https://help.tableau.com/current/pro/desktop/en-us/performance_tips.htm) through [update workbook connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_workbook_connection) and [update data source connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#update_data_source_connection). They can view enablement status through [query workbook connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbook_connections) and [query data source connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_data_sources.htm#query_data_source_connections).

## REST API 3.11 for Tableau Server 2021.1 and Tableau Cloud

- Add quality warning triggers to extract data sources and flows.
    
    Quality warning triggers, applied to extract data sources and flows, monitor for and display alerts, along side other DQWs, when refreshes or flow runs fail. For more information, see the following methods: [Add Quality Warning Triggers](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_dqw_trigger), [Update Quality Warning Trigger](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_dqw_trigger), [Query Quality Warning Trigger](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_dqw_trigger), [Query Quality Warning Triggers](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_dqw_triggers), [Delete Quality Warning Trigger](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_dqw_trigger), and [Delete Quality Warning Triggers](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_dqw_triggers).
- List the Active Directory domains in use on a Tableau Server and update a domain's name and nickname on a server using the [List Server Active Directory Domains](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_server.htm#list_server_active_directory_domains) and [Update Server Active Directory Domain](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_server.htm#update_server_active_directory_domain) methods.
- If you have Tableau Server administrator permissions, you can now use a [personal access token](https://help.tableau.com/current/server/en-us/security_personal_access_tokens.htm) (PAT), instead of a user name and password to more securely impersonate users on a server. You can also revoke all server administrator PATs using the Revoke Administrator Personal Access Tokens method. [Learn more.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_authentication.htm)

## REST API 3.10 for Tableau Server 2020.4 and Tableau Cloud

- New REST endpoints have been added to [manage metrics on your Tableau site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metrics.htm). You can now [list all metrics for a site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metrics.htm#list_metrics_for_site), [get the details of a specified metric](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metrics.htm#get_metric), [update the properties of a metric](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metrics.htm#update_metric), and [delete a metric](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metrics.htm#delete_metric) through REST requests.
- [Analytics Extensions methods](https://help.tableau.com/current/api/rest_api/en-us/REST/TAG/index.html#tag/Analytics-Extensions-Settings) are now available for Tableau Cloud.
- The `flowsEnabled` attribute for sites is deprecated and is replaced with `editingFlowsEnabled` and `schedulingFlowsEnabled` to provide more granular control over editing and scheduling flows. For more information, see [Create Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_site).
- You can now get a list of flow runs for a site and details of a specific flow run. You can also cancel a specific flow run. For more information, see [Get Flow Run](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#get_flow_run), [Get Flow Runs](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#get_flow_runs), and [Cancel Flow Run](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm#cancel_flow_run).

## REST API 3.9 for Tableau Server 2020.3 and Tableau Cloud

- With the appropriate permissions, you can do the following:
    
    - Add and delete tags for databases, tables, and columns using the following methods: [Add Tags to Database](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_database), [Add Tags to Table](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_table), [Add Tags to Column](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_column), [Delete Tag from Database](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tags_database), [Delete Tag from Table](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tags_table), and [Delete Tag from Column](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tags_column).
    - Batch update tags on Tableau content and external assets using the following methods: [Batch Add Tags](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#batch_add_tags) and [Batch Delete Tags.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#batch_delete_tags)
- You can set a data quality warning for sensitive data. For more information, see [Add Data Quality Warning.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_dqw)

## REST API 3.8 for Tableau Server 2020.2 and Tableau Cloud

- You can enable high visibility for a data quality warning using the following methods: [Add Data Quality Warning](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_data_quality_warning) and [Update Data Quality Warning](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#update_data_quality_warning).
- Administrators can now enable data acceleration for specific workbooks. The workbook loads faster because Tableau Server precomputes the workbook's data in a background process. For more information, see [Data Acceleration](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_data_acceleration.htm).
- The details of the current server session can now be viewed by calling [Get Current Server Session](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get-current-server-session). The response includes identifiers and configuration information for the current site and user.
- You can now call [Download Workbook PowerPoint](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#download_workbook_powerpoint) to download images of views and dashboards in a workbook as slides in a PowerPoint deck (`.pptx` file).
- Settings for [Analytics Extensions](#) and [Dashboard Extensions](#) can now be configured using the REST API. These endpoints introduce a new form of RESTful API to the set of Tableau automation tools. To learn more, see [REST API and Resource Versions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).
- Organize a user's favorites. For more information, see [Favorites Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_favorites.htm#update_favorites).

## REST API 3.7 for Tableau Server 2020.1 and Tableau Cloud

- Administrators can now use [Get Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_site) or [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_site) to view the Tiered Capacities (maximum users of a site for each license type or role) configured for a site. For a site that has user-based licensing with no licensing limits set by its administrator, maximums for Creator, Explorer, and Viewer licensed users are determined by the activated licenses for each role on the site. On-premise server administrators can set the Tiered Capacity attributes to lower the user limits on any or all of the license types using [Create Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_site) or [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_site).
- You can now [get the groups a site user belongs to](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_groups_for_a_user) with a REST API call.
- You can now manage view recommendations using the REST API. Use [Get View Recommendations](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_view_recommendations), to get a current list of recommended views. Use [Hide a View Recommendation](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#hide_view_recommendations), to hide a view from the list of recommended views. Use [Unhide a View Recommendation](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#unhide_view_recommendations), to hide a view from the list of recommended views.

## REST API 3.6 for Tableau Server 2019.4

- With the appropriate permissions, you can query, set, and delete permissions on databases and tables using the following methods: [Add Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_database_perms), [Query Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#query_database_perms), [Add Default Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_database_perms_default), [Query Default Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#query_database_perms_default), [Delete Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#delete_database_perms), [Delete Default Database Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_database_perms_default), [Add Table Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_table_perms), [Query Table Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#query_table_perms), [Delete Table Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm#add_table_perms).
- You can now use a [Personal Access Token](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_auth.htm#make-a-sign-in-request-with-a-personal-access-token) (PAT), instead of plain text username and password, to sign in to Tableau Server or Online with the REST API. Signing in with a PAT returns the same form of credentials token as a password sign in, but PATs are more secure because they are revocable, they can be easily monitored, and they avoid revealing identifying information in scripts and tools. Administrators can make the impact of each process more visible by using separate PATs for each process. PATs allow you to change sign in credentials for a user without affecting their Tableau user credentials.
- Using [Tableau Webhooks](https://github.com/tableau/webhooks-docs/tree/master#tableau-webhooks-documentation), you can now build custom applications or workflows that react to events that happen in Tableau. For example, you could use webhooks to send an SMS or Slack notification any time a data source refresh fails. Use the REST API to create and manage your webhooks for a site. This initial release enables 13 workbook, data source and view events to fire notifications to destination URL of your choosing.

## REST API 3.5 for Tableau Server 2019.3

- You can now manage extract encryption at rest. To learn more, see [Extract Encryption Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_extract_and_encryption.htm).
- You can query or update metadata indexed by or surfaced through Tableau Catalog. To learn more, see [Metadata Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_metadata.htm).
- With administrator permissions, you can now globally enable or disable attachments for subscriptions to workbooks and views in a site. You can read the enablement status in response bodies for [Query Sites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#query_sites), [Query Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#query_site), [Create Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#create_site), and [Update Sites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_site.htm#update_site) requests. Enablement state can be set during Create Site and Update Site calls.
- Users can now determine the file format (`.png` and/or `.pdf`) of the attachments for a subscribed workbook or view. Attachment settings can be viewed in response bodies for [Query Subscriptions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#query_subscriptions), [Query Subscriptions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#query_subscription), [Create Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#create_subscription), and [Update Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_subscriptions.htm#update_subscription) requests. Attachment format can be set using Create Subscription or Update Subscription requests.

## REST API 3.4 for Tableau Server 2019.2

- You can now use the maxAge parameter of the [Query View Image](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#query_view_image) method to set or get the limit for the age of a cached image of a view in your workbook. When that limit is passed accessing a view image will refresh the cache with a current image.
- You can now use the public parameter of the [Get Data-Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data-driven_alerts) method to set or get whether users who do not own an alert can discover and subscribe to it.
- You can now use the [Download Workbook PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_workbooks_and_views.htm#download_workbook_pdf) method to download a PDF containing the views in the a workbook.

## REST API 3.3 for Tableau Server 2019.1

- When you publish a workbook that contains a user filter, you can now specify which user should be used to generate thumbnails by using the generateThumbnailsAsUser attribute. To learn more, see [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook).
- You can now manage flows. To learn more, see [Flow Methods](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref_flow.htm), [Add Flow to Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_flow_to_favorites), and [Delete Flow from Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_flow_from_favorites).

## REST API 3.2 for Tableau Server 2018.3

- When you call the [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook) method with hidden sheets (also known as views) those sheets are no longer included in the published workbook.
- You can now manage permissions for views using the [Add View Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_view_permissions), [Query View Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_permissions), and [Delete View Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_view_permission) methods.
- You can now manage data-driven alerts using the [Query Data-Driven Alerts](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data-driven_alerts), [Query Data-Driven Alert Details](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data-driven_alert_details), [Update Data-Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data-driven_alert), [Delete Data-Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_data-driven_alert), [Add User to Data-Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_user_to_data-driven_alert), and [Delete User from Data-Driven Alert](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_user_from_data-driven_alert) methods.

## REST API 3.1 for Tableau Server 2018.2

- You can now move projects within the project hierarchy. You can now move projects to the top of the project hierarchy when using the [Update Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Update) method by passing an empty string ("") to the **parentProjectId** attribute of the **<project>** element.
- You can now manage and cancel jobs. The following methods have been updated or added in the 2018.2 release to improve the management of jobs:
    - **Added**: The [Query Jobs](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_jobs) method returns a list of all active jobs on the specified site.
    - **Added**: The [Cancel Job](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#cancel_job) method allows you to cancel a job that is pending or in-progress.
    - **Updated**: The [Query Job](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_job) method now allows you to query jobs used to run workbook subscriptions or view subscriptions.
- You can now manage which projects are included on a user's list of favorites, and query a list of favorites that includes favorite projects using the following methods that have been updated or added in the 2018.2 release:
    - **Added**: [Add Project to Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_project_to_favorites)
    - **Added**: [Delete Project from Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_project_from_favorites)
    - **Updated**: [Get Favorites for User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_favorites_for_user)
- You can now publish data sources asynchronously by adding the _asJob_ parameter to the Publish Data Source request URI. To learn more, see [Publishing workbooks and data sources asynchronously](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_publish.htm#async).

## REST API 3.0 for Tableau Server 2018.1

- You can now publish workbooks that use multiple data source connections. To learn more, see [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook).
- Starting with the 2018.1 release of Tableau Server and Tableau Cloud, available site roles have changed significantly to support the new user-based Creator, Explorer and Viewer licenses. To learn more, see [Updated Site Roles in REST API 3.0](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_new_site_roles.htm).
- You can now publish workbooks asynchronously by adding the _asJob_ parameter to the Publish Workbook request URI. To learn more, see [Publishing workbooks asynchronously](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_publish.htm#async).
- Additional fields are now available when making queries using the REST API:
    
    - To format views, you can use the _sheetType_ field with the [Query Views for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_views_for_site) method.
    - To see workbook descriptions, you can use the _description_ field with the [Query Workbooks for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbooks_for_site) and [Query Views for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_views_for_site) methods.
    
    To learn more, see [Using fields in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_fields.htm).

## REST API 2.8 for Tableau Server 10.5

- You can now filter results from the [Query View Image](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_image), [Query View Data](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_data) and [Query View PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_pdf) methods by specific workbook field values. To learn more, see [Filter query views](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_filtering_and_sorting.htm#Filter-query-views).
- Create or update project hierarchies. A project can now contain other projects. For more information about nested projects, see the following methods:
    
    - [Create Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Create)
    - [Update Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Update)
- Export workbook views as .pdf files or comma-separated values. Similar to the [Query View Image](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_image) method, you can now export workbook views using the [Query View Data](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_data) and [Query View PDF](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_pdf) methods.
- Refresh workbooks and data source extracts without associating them with a schedule. To learn more, see [Update Data Source Now](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data_source_now) and [Update Workbook Now](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_workbook_now).
- Add workbooks and data sources to a schedule. You can now add workbook refreshes and data source extract refreshes to an existing schedule. To learn more, see [Add Workbook to Server Schedule](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_workbook_to_schedule) and [Add Data Source to Server Schedule](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_data_source_to_schedule).
- The Update User method now supports the **ServerAdministrator** site role. Users who are in the **ServerAdministrator** site role can now add or remove other users from that site role. To learn more, see [Update User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_user).

## REST API 2.7 for Tableau Server 10.4

- Filtering and sorting can now be performed on the following additional methods:
    
    - [Query Groups](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_groups)
    - [Query Projects](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_projects)
        
        For information, see [Filtering and Sorting in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_filtering_and_sorting.htm)
- The permissions required to move a data source from one project to another have been improved for non-server administrators.  
    Users who either own the data source or the current project, or are project leaders for the current project, can update a data source if they have write permissions for the new project. See [Update Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data_source)
- Improved pagination. Results returned from methods that support pagination, such as [Query Data Sources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_sources) or [Query Projects](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_projects), are now indexed and sorted internally, ensuring consistent results across method calls. See [How Elements are Ordered](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_paging.htm#how_elements_are_ordered).
- Certification notes and status. The [Update Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data_source) method now supports setting certification status and adding a certification note. To learn more about data source certification, see [Use Certified and Recommended Data Sources and Tables](https://help.tableau.com/current/pro/desktop/en-us/datasource_recommended.html).

## REST API 2.6 for Tableau Server 10.3

- New feature for querying a site for refresh tasks and running an extract refresh job. For more information, see the following methods:
    
    - [Get Extract Refresh Task](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_extract_refresh_task)
    - [Get Extract Refresh Tasks](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_extract_refresh_tasks)
    - [Run Extract Refresh Task](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#run_extract_refresh_task)
- New methods for tagging data sources and views.
    
    - [Add Tags to Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_to_data_source)
    - [Delete Tag from Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tag_from_data_source)
    - [Add Tags to View](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_to_view)
    - [Delete Tag from View](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tag_from_view)
- New method that makes it easy to switch sites. You no longer need to provide a user name and password every time. See [Switch Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#switch_site).
- Update to [Query Sites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_sites). No longer just for server administrators. Now returns only the sites that the user making the call has access to.

## REST API 2.5 for Tableau Server 10.2

- New method for getting views and workbooks that a user has marked as favorites. For more information, see [Get Favorites for User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_favorites_for_user).
- New method for getting images for views. You can get images in standard resolution and high resolution. For more information, see [Query View Image.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_view_image)
- A new feature you can use to control the type and amount of data you want returned from some methods. You can qualify the return values based upon the type of resource (for example, workbooks or views), and fields (names, ids, and tags). You can include multiple fields in a request. You can combine this feature with filtering and sorting. For example, you can return the names of the all workbooks that were updated after a certain date. For more information, see [Using Fields in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_fields.htm).
- Support for JSON in the REST API. You can set `Content-Type` and `Accept` headers to `application/json` or `application/xml` to control whether you want send requests or receive responses in XML or JSON. For more information, see [Fundamentals of the Tableau Server REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_fundamentals.htm) and [REST API Example Requests](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_example_requests.htm).
- Support for _Cross Origin Resource Sharing_ (CORS). You can now enable CORS on Tableau Server to allow cross-orgin requests to the REST API, making it easier to use the API with JavaScript. For more information, see [Enabling CORS on Tableau Server for the REST API.](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_fundamentals.htm#Enabling)
- Download workbooks or data sources without including the extracts. You can now download a data source or workbook without the large payload of the extract file by simply appending `?includeExtract=False` to the URI. For more information, see the following methods:
    
    - [Download Data Dource](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Download)
    - [Download Data Source Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Download2)
    - [Download Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Download3)
    - [Download Workbook Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Download4)
- New option to publish the Tableau provided sample workbooks when you create or update a project. For more information see the following methods:
    
    - [Create Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Create)
    - [Update Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#Update)

## REST API 2.4 for Tableau Server 10.1

- The [Server Info](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#server_info) method returns information about the version of Tableau Server and the version of the REST API compatible with the server.
- Site administrators can now use the method to [Query Workbooks for a User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbooks_for_user). Previously, only server administrators had permission to use this method.
- Filtering and sorting can be performed on the following additional methods:
    
    - [Query Data Sources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_sources)
    - [Query Views for Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_views_for_site)

## REST API 2.3 for Tableau Server 10.0

- A new feature that lets you add filter (`name`, `createdDate`, `tags`, and so on) to some methods. For example, instead of having to get all the users or workbooks for a site and then loop through them looking for a specific ones, you can add a filter to the method call to return just the users or workbooks you're interested in. You can also specify sort parameters to return the items in a defined order.
    
    For more information, see [Filtering and Sorting in the REST API](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_concepts_filtering_and_sorting.htm).
- New and updated methods for viewing, downloading, and removing versions (revisions) for workbooks and data sources:
    
    - [Get Data Source Revisions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_data_source_revisions)
    - [Download Data Source Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#download_data_source_revision)
    - [Remove Data Source Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#remove_data_source_revision)
    - [Get Workbook Revisions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_workbook_revisions)
    - [Download Workbook Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#download_workbook_revision)
    - [Remove Workbook Revision](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#remove_workbook_revision)
    - [Query Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_site). Now returns information about versioning settings for the site.
    - [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_site). Now lets you change versioning settings for the site.
- New methods for creating and deleting schedules:
    
    - [Create Schedule](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_schedule)
    - [Delete Server Schedule](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_schedule)
- New methods for creating, viewing, and deleting subscriptions:
    
    - [Create Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_subscription)
    - [Query Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_subscription)
    - [Query Subscriptions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_subscriptions)
    - [Update Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_subscription)
    - [Delete Subscription](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_subscription)
- New methods for adding and removing data sources from a user's favorites:
    
    - [Add Data Source to Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_data_source_to_favorites)
    - [Delete Data Source from Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_data_source_from_favorites)
- New and updated methods for working with multiple connections in a data source. Starting with Tableau Server 10.0, data sources can have multiple connections. This version of the REST API includes the following changes:
    
    - [Update Data Source Connection](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data_source_connection). This method has new syntax that lets you specify which connection in a data source you want to update.
        
        **Note**: If the data source was created in Tableau 9.3 or earlier, the [previous syntax for this method](https://help.tableau.com/v9.3/api/rest_api/en-us/help.htm#REST/rest_api_ref.htm#Update_Datasource_Connection) (without `/connections/connection-id` in the URI) will work for updating that data source. However, we recommend that you use the syntax documented here for all data sources.
    - [Query Data Source Connections](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_source_connections). This new method returns information about all the connections in a data source.
- Updates to the [Update Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_site) to let you upload a new logo image to a Tableau Cloud site.

## REST API 2.2 for Tableau Server 9.3

- New methods for querying schedules and tasks:
    
    - [List Server Schedules](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_schedules)
    - [Query Extract Refresh Tasks](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_extract_refresh_tasks)
- The [Query Views for Sites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_views_for_site) method.
- A new append parameter for the [Publish Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_data_source) method that lets you add data to a data source that was published previously.
- A new `size` attribute was added to the response for these methods:
    
    - [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook)
    - [Query Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbook)
    - [Query Workbooks for User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbooks_for_user)
    - [Update Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_workbook)
- New `createdAt` and `updatedAt` attributes were added to the response for these methods:
    
    - [Publish Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_data_source)
    - [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook)
    - [Query Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_source)
    - [Query Data Sources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_sources)
    - [Query Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbook)
    - [Query Workbooks for User](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbooks_for_user)
    - [Update Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_data_source)
    - [Update Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_workbook)

## REST API 2.1 for Tableau Server 9.2

- New methods for setting default permissions. The REST API now has the following methods that let you set, view, and remove default permissions for a project. Default permissions let you specify a set of permissions that are applied to new content in a project.
    
    - [Add Default Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_default_permissions)
    - [Query Default Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_default_permissions)
    - [Delete Default Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_default_permission)
- Updated methods to support locking of project permissions. Permissions in a project can now be "locked" so that users cannot change permissions on individual workbooks or data sources in that project. The following methods have been updated in the REST API to enable you to lock or unlock permissions, or to view project default permissions.
    
    - [Create Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_project)
    - [Query Data Source Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_source_permissions)
    - [Query Projects](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_projects)
    - [Query Workbook Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_workbook_permissions)
    - [Update Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#update_project)
- Changes to the project capabilities that you can set or delete permissions for. Starting in Tableau Server 9.2, projects support only these capabilities: Read (view), Write (save), and ProjectLeader. (In Tableau Server 9.1 and earlier, you could set capabilities that could apply to all content in the project.)
    
    **Note**: This is a change in the permissions model for Tableau Server itself, not just in the API. In Tableau Server 9.2, you cannot set permissions for any project capability except the ones listed here, even if you specify a previous version of the REST API in the URI.
    
    This change affects the following methods:
    
    - [Add Project Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_project_permissions)
    - [Delete Project Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_project_permission)
    - [Query Project Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_project_permissions)
    
    To set capabilities that apply to content in the project, you can use the new methods for setting default permissions (see earlier items in this list).
- Updated permissions for some methods to allow them to be called by site administrators in addition to server administrators. This also has the effect of making those methods available in Tableau Cloud. These are the affected methods:
    
    - [Add Data Source Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_data_source_permissions)
    - [Add Project Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_project_permissions)
    - [Add Tags to Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_tags_to_workbook)
    - [Add User to Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_user_to_group)
    - [Add User to Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_user_to_site)
    - [Add View to Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_view_to_favorites)
    - [Add Workbook Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_workbook_permissions)
    - [Add Workbook to Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#add_workbook_to_favorites)
    - [Append to File Upload](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#append_to_file_upload)
    - [Create Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_group)
    - [Create Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#create_project)
    - [Delete Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_data_source)
    - [Delete Data Source Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_data_source_permission)
    - [Delete Project](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_project)
    - [Delete Project Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_project_permission)
    - [Delete Tag from Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_tag_from_workbook)
    - [Delete View from Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_view_from_favorites)
    - [Delete Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_workbook)
    - [Delete Workbook from Favorites](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_workbook_from_favorites)
    - [Delete Workbook Permission](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#delete_workbook_permission)
    - [Download Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#download_data_source)
    - [Download Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#download_workbook)
    - [Get Users in Group](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_users_in_group)
    - [Get Users on Site](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#get_users_on_site)
    - [Initiate File Upload](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#initiate_file_upload)
    - [Publish Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_data_source)
    - [Publish Workbook](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#publish_workbook)
    - [Query Data Source](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_source)
    - [Query Data Source Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_source_permissions)
    - [Query Data Sources](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_data_sources)
    - [Query Groups](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_groups)
    - [Query Project Permissions](https://help.tableau.com/v0.0/api/rest_api/en-us/REST/rest_api_ref.htm#query_project_permissions)
[...]
